/* Don't edit this file - it is generated automatically from
   prot-a-parse-arg-c.awk and fncdef.txt */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <sys/types.h>
#include <sys/socket.h>
#include <stdarg.h>
#include <setjmp.h>
#include <time.h>

#include "s-string.h"
#include "kom-types.h"
#include "com.h"
#include "isc-interface.h"
#include "async.h"
#include "connections.h"
#include "isc-parse.h"
#include "server/smalloc.h"
#include "prot-a.h"
#include "prot-a-parse.h"
#include "prot-a-parse-arg.h"
#include "kom-config.h"
#include "param.h"

void
prot_a_parse_arg_login_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string0, (param.pwd_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_logout(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_change_conference(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_change_name(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_change_what_i_am_doing(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->string0, (param.what_do_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_person_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string1, (param.pwd_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_person_stat_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_priv_bits(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_priv_bits(client, &client->priv_bits);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_passwd(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string0, (param.pwd_len));
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_string(client, &client->c_string1, (param.pwd_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_query_read_texts_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_conf_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_conf_type(client, &client->conf_type);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_delete_conf(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_lookup_name(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_conf_stat_older(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_add_member_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
	client->fnc_parse_pos = 3;
    case 3:
	client->num3 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_sub_member(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_presentation(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_etc_motd(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_supervisor(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_permitted_submitters(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_super_conf(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_conf_type(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_conf_type(client, &client->conf_type);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_garb_nice(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_marks(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_mark_text_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_text_stat_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_mark_as_read(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	if ( parse_nonwhite_char(client) != '{' )
	    longjmp(parse_env, ISC_PROTOCOL_ERR);
	if ( client->num1 > (param.mark_as_read_chunk) )
	    longjmp(parse_env, ISC_PROTOCOL_ERR);

	client->c_local_text_no_p = smalloc(client->num1
					    * sizeof(Local_text_no));

	client->array_parse_index = 0;
	client->fnc_parse_pos = 3;
    case 3:
	while( client->array_parse_index < client->num1 )
	{
	    client->c_local_text_no_p[ client->array_parse_index ]
		= prot_a_parse_long(client);
	    ++client->array_parse_index;
	}
	client->fnc_parse_pos = 4;
    case 4:
	if ( parse_nonwhite_char(client) != '}' )
	    longjmp(parse_env, ISC_PROTOCOL_ERR);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_text_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.text_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_misc_info_list(client, &client->misc_info_list, (param.max_crea_misc));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_delete_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_add_recipient(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_sub_recipient(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_add_comment(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_sub_comment(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_map(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_time(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_info_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_add_footnote(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_sub_footnote(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_who_is_on_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_unread(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_motd_of_lyskom(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_enable(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_sync_kom(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_shutdown_kom(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_broadcast(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.broadcast_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_membership_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
	client->fnc_parse_pos = 3;
    case 3:
	client->num3 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_created_texts(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_members_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_person_stat(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_conf_stat_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_who_is_on(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_unread_confs(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_send_message(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string0, (param.broadcast_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_session_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_disconnect(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_who_am_i(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_user_area(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_last_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_time_date(client, &client->time);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_anonymous_text_old(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.text_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_misc_info_list(client, &client->misc_info_list, (param.max_crea_misc));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_find_next_text_no(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_find_previous_text_no(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_login(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string0, (param.pwd_len));
	client->fnc_parse_pos = 2;
    case 2:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_who_is_on_ident(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_session_info_ident(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_re_lookup_person(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.regexp_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_re_lookup_conf(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.regexp_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_lookup_person(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_lookup_conf(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_client_version(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.client_data_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string1, (param.client_data_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_client_name(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_client_version(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_mark_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_unmark_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_re_z_lookup(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.regexp_len));
	client->fnc_parse_pos = 1;
    case 1:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_version_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_lookup_z_name(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
	client->fnc_parse_pos = 1;
    case 1:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_last_read(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_uconf_stat(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_info(client, &client->info);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_accept_async(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_num_list(client, &client->num_list, (param.accept_async_len));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_query_async(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_user_active(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_who_is_on_dynamic(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_static_session_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_collate_table(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.text_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_misc_info_list(client, &client->misc_info_list, (param.max_crea_misc));
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_aux_item_list(client, &client->aux_item_list, (param.max_add_aux));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_anonymous_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.text_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_misc_info_list(client, &client->misc_info_list, (param.max_crea_misc));
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_aux_item_list(client, &client->aux_item_list, (param.max_add_aux));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_conf(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_conf_type(client, &client->conf_type);
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_aux_item_list(client, &client->aux_item_list, (param.max_add_aux));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_create_person(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_string(client, &client->c_string0, (param.conf_name_len));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_string(client, &client->c_string1, (param.pwd_len));
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_pers_flags(client, &client->pers_flags);
	client->fnc_parse_pos = 3;
    case 3:
	prot_a_parse_aux_item_list(client, &client->aux_item_list, (param.max_add_aux));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_text_stat(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_conf_stat(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_modify_text_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_num_list(client, &client->num_list, (param.max_delete_aux));
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_aux_item_list(client, &client->aux_item_list, (param.max_add_aux));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_modify_conf_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_num_list(client, &client->num_list, (param.max_delete_aux));
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_aux_item_list(client, &client->aux_item_list, (param.max_add_aux));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_modify_server_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	prot_a_parse_num_list(client, &client->num_list, (param.max_delete_aux));
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_aux_item_list(client, &client->aux_item_list, (param.max_add_aux));
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_query_predefined_aux_items(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_expire(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_query_read_texts(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_membership(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
	client->fnc_parse_pos = 3;
    case 3:
	client->num3 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_add_member(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
	client->fnc_parse_pos = 3;
    case 3:
	client->num3 = prot_a_parse_long(client);
	client->fnc_parse_pos = 4;
    case 4:
	prot_a_parse_membership_type(client, &client->membership_type);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_get_members(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_membership_type(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	prot_a_parse_membership_type(client, &client->membership_type);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_local_to_global(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_map_created_texts(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
	client->fnc_parse_pos = 2;
    case 2:
	client->num2 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_keep_commented(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_pers_flags(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	prot_a_parse_pers_flags(client, &client->pers_flags);
    default:
	client->fnc_parse_pos = 0;
    }
}

#ifdef DEBUG_CALLS
void
prot_a_parse_arg_get_memory_info(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_set_marks(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_backdate_text(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    case 0:
	client->num0 = prot_a_parse_long(client);
	client->fnc_parse_pos = 1;
    case 1:
	client->num1 = prot_a_parse_long(client);
    default:
	client->fnc_parse_pos = 0;
    }
}

void
prot_a_parse_arg_start_garb(Connection *client)
{
    switch( client->fnc_parse_pos )
    {
    default:
	client->fnc_parse_pos = 0;
    }
}

#endif
/* end of this auto generated file. */
