/*
 * $Id: acconfig.h,v 1.7 1999/06/25 21:21:11 ceder Exp $
 * Copyright (C) 1998-1999  Lysator Academic Computer Association.
 *
 * This file is part of the LysKOM server.
 * 
 * LysKOM is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 1, or (at your option) 
 * any later version.
 * 
 * LysKOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with LysKOM; see the file COPYING.  If not, write to
 * Lysator, c/o ISY, Linkoping University, S-581 83 Linkoping, SWEDEN,
 * or the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, 
 * MA 02139, USA.
 *
 * Please mail bug reports to bug-lyskom@lysator.liu.se. 
 */


/* This should be defined if you want gcov statistics.
   It replaces some aborts with exits so coverage data
   is output */
#undef AVOID_ABORTS

/* Define if you want to define special debugging calls.
   If you don't know if you need this, you don't. */
#undef DEBUG_CALLS

/* Define if your OS has buggy inet_ntoa. 
   If you don't know, define this */
#define BUGGY_INET_NTOA

/* Define if you want encrypted passwords */
#define ENCRYPT_PASSWORDS

/* Define if your compiler supports __attribute__ in printf */
#undef HAVE_ATTRIBUTE_FORMAT_PRINTF

/* Define if your compiler supports __attribute__ unused */
#undef HAVE_ATTRIBUTE_UNUSED

/* Define if your OS has struct sigaction */
#undef HAVE_STRUCT_SIGACTION

/* Define this to a type that can be changed atomically from a signal
   handler if your OS lacks sig_atomic_t.  */
#undef sig_atomic_t

/* Define if on HPUX */
#ifndef _HPUX_SOURCE
#undef _HPUX_SOURCE
#endif

/* Should all allocations be traced?  See src/server/ram-smalloc.c for
   more information. */
#undef TRACED_ALLOCATIONS
