dnl $Id: acinclude.m4,v 1.3 1999/05/24 09:38:13 ceder Exp $
dnl Copyright (C) 1994-1995, 1998-1999  Lysator Academic Computer Association.
dnl
dnl This file is part of the LysKOM server.
dnl 
dnl LysKOM is free software; you can redistribute it and/or modify it
dnl under the terms of the GNU General Public License as published by 
dnl the Free Software Foundation; either version 1, or (at your option) 
dnl any later version.
dnl 
dnl LysKOM is distributed in the hope that it will be useful, but WITHOUT
dnl ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
dnl FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
dnl for more details.
dnl 
dnl You should have received a copy of the GNU General Public License
dnl along with LysKOM; see the file COPYING.  If not, write to
dnl Lysator, c/o ISY, Linkoping University, S-581 83 Linkoping, SWEDEN,
dnl or the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, 
dnl MA 02139, USA.
dnl
dnl Please mail bug reports to bug-lyskom@lysator.liu.se. 
dnl

dnl
dnl Check if an option is acceptable to the C compiler in use.
dnl (This is taken verbatim from cmod 1.0.  Please don't make even a
dnl tiny change to it unless you change the name of all variables!
dnl See the cmod source code for more information.)
dnl
AC_DEFUN(CMOD_COMPILER_CC_ACCEPTS,
[cmod_safe=`echo "cmod_cv_compiler_${CC}_accepts_$1" | tr '+./=\055' 'X____'`
AC_MSG_CHECKING([whether ${CC} accepts $1])
AC_CACHE_VAL($cmod_safe,
[[cmod_oldflags=$CFLAGS
CFLAGS="$CFLAGS $1"]
AC_TRY_LINK(,,
	[eval "$cmod_safe=yes"],
	[eval "$cmod_safe=no"])
[CFLAGS=$cmod_oldflags]])dnl
AC_MSG_RESULT([`eval echo '$'$cmod_safe`])
if test `eval echo '$'$cmod_safe` = yes; then
  CFLAGS="$CFLAGS $1"
fi])dnl
dnl
dnl Another frozen defun.
dnl
AC_DEFUN(CMOD_C_ATTRIBUTE_UNUSED,
[AC_MSG_CHECKING([whether $CC understands __attribute__((unused))])
AC_CACHE_VAL([cmod_cv_c_attribute_unused_understood],
    AC_TRY_COMPILE(,[int i __attribute__((unused));],
	[cmod_cv_c_attribute_unused_understood=yes],
	[cmod_cv_c_attribute_unused_understood=no]))
AC_MSG_RESULT($cmod_cv_c_attribute_unused_understood)
[if test $cmod_cv_c_attribute_unused_understood = yes ; then]
    AC_DEFINE(HAVE_ATTRIBUTE_UNUSED)
[fi]])dnl
